// MakeBMP
// Mika Laitinen
// (& Teemu Roos)
// 7.10.2011
// Johdatus tekoälyyn-kurssin 5. laskuharjoitukset
// Esimerkkikoodia tiedostojen lukemiseen ja numeroiden
// esittämiseen kuvina. Muokkaa koodia tehtävänannon
// mukaisesti toteuttamalla k:n lähimmän naapurin
// luokitin. 

import java.awt.*;
import java.awt.image.*;
import javax.imageio.*;
import java.io.*;
import java.util.*;

class Image implements Comparable<Image> {
    public Vector<Boolean> vec;
    public int characterClass;

    public Image() {

    }

    public int compareTo(Image i1) {
        return this.characterClass - i1.characterClass;
    }
}

public class MakeBMP {
    static Vector<Image> I = new Vector<Image>();

    static void readImages(String xfilename, String yfilename) {
        try {
            Scanner xscanner = new Scanner(new File(xfilename));
            Scanner yscanner = new Scanner(new File(yfilename));
            while(xscanner.hasNextLine()) {
                Image i = new Image();
                String line = xscanner.nextLine();
                int characterClass = yscanner.nextInt();
                String splitarr[] = line.split(",");
                Vector<Boolean> vb = new Vector<Boolean>();
                for(String s : splitarr) {
                    if(s.equals("1")) {
                        vb.addElement(Boolean.TRUE);
                    } else vb.addElement(Boolean.FALSE);
                }
                i.vec = vb;
                i.characterClass = characterClass;
                I.addElement(i);
            }
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    static void writeBMP(Image i, String filename) {
        BufferedImage bi = new BufferedImage(28,28,BufferedImage.TYPE_3BYTE_BGR); 
        for(int y = 0; y < 28; ++y) {
            for(int x = 0; x < 28; ++x) {
                int ind = y*28+x;
                bi.setRGB(x,y,(i.vec.elementAt(ind)?0:0xffffff));
            }
        }
        try {
            ImageIO.write(bi,"BMP",new File(filename));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static void testInput() {
        // otetaan sata ensimmaista, jarjestetaan characterClassin
        // mukaan, ja piirretaan iso kuva, ja katsotaan etta samat
        // kirjaimet tulevat perakkain

        Vector<Image> I100 = new Vector<Image>();
        for(int i = 0; i < 100; ++i) I100.addElement(I.elementAt(i));

        Collections.sort(I100);

        BufferedImage bi = new BufferedImage(28*100,28,
                BufferedImage.TYPE_3BYTE_BGR);

        for(int i = 0; i < 100; ++i) {
            for(int y = 0; y < 28; ++y) {
                for(int x = 0; x < 28; ++x) {
                    int ind = y*28+x;
                    bi.setRGB(x+i*28,y,
                            (I100.elementAt(i).vec.elementAt(ind)?
                             0:0xffffff));
                }
            }
        }
        try {
            ImageIO.write(bi,"BMP",new File("test100.bmp"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
	// ensimmäinen komentoriviparametri antaa numeroiden
	// bittikarttaesitykset sisältävän tiedoston, toinen
	// vastaavat oikeat luokitukset.
        readImages(args[0],args[1]);
        testInput();
    }
};
